% Ethernet Switch 1 (Data Path and OF Client)
% -------------------------------------------

% DestMACAddress   = 'BBBBBBBBBBBB';
% SourceMACAddress = 'AAAAAAAAAAAA';


% Input Ethernet frame data (incoming packet from Host PC A)
%DA = DestMACAddress;
%SA = SourceMACAddress;
EType = '0800';%EtherType;  %MA: 
Pre = '55555555555555';
SFD = 'D5'; %MA: modifeied from D5 to D51

HexStrInput = strcat(Pre,SFD,DA,SA,EType); % array of characters or String
%HexStrInput = strcat('5','D','B','A','8'); % MA: check lengths ofvariables
HexStrInput = HexStrInput(~isspace(HexStrInput));
n = length(HexStrInput); % MA: n is 44 characters

% Convert from hexadecimal string to binary string
Binary = '';  %MA: Binary length will be 44 char* 8 bits (notes there are 4 spaces (would be counted as empty characters) between 0 and 1 bits )  
                  % so total will be 352 bits and there is a space in between
for h = 1 : n
    Binary = [Binary h2b(HexStrInput(h))];
end

% Convert binary string to row vector of doubles
Seq = str2num(Binary); %MA: seq is the halh size of binary as the function here is the count of numbers only but 

% FLOW TABLES (Ref: HP OpenFlow Protocol Overview Technical Solution Guide,Version: 1, September 2013)
% http://h17007.www1.hp.com/docs/networking/solutions/sdn/devcenter/03_-_HP_OpenFlow_Technical_Overview_TSG_v1_2013-10-01.pdf 

    % RULES/HEADER
    % Switch port/VLAN ID/VLAN PCP/MAC Source Address/MAC Destination Address/Ethernet Type/
    % IP Source Address/IP Destination Address/IP ToS/IP Protocol/L4 Source Port/L4 Destination Port

    % ACTIONS: Forward to one or more ports, Drop, Encapsulate and forward to
    % controller, Send to normal processing pipeline, Modify fields

    % STATS: Packet Counter, Byte Counter

% Switch 1 (Open Flow Table) % it should be characters 
OFT1_SwitchPort = ' ';
OFT1_VLANID = ' ';
OFT1_PCP = ' ';
OFT1_MACSA = ' ';
OFT1_MACDA = 'BBBBBBBBBBBB';
OFT1_EthType = ' ';
OFT1_IPSource = ' ';
OFT1_IPDest = ' ';  
OFT1_TOS = ' ';
OFT1_Protocol = ' ';
OFT1_L4SP = ' ';  
OFT1_L4DP = ' ';

% Import data from Flow Controller message
fileID = fopen('OF1.txt');
C1 = textscan(fileID,'%s %s');
fclose(fileID);

% Actions (Instruction(s) from OF Controller)
% Read in data 
DestMAC1 = C1{2}{1};
Inst1 = C1{2}{2};
% Forward incoming packet to output port (P2) if there is a match with flow
% table
if strcmp (DestMACAddress,DestMAC1)
   Action = Inst1;
else
   Action = 'None';
end
    
% Creating an output structure similar to the input
OutputPort1 = InputPort1;

if strcmp(Action, Inst1)
    
    % Allocate binary sequence to output port (Frame data)
    cs = length(Seq);
    for m = 1 : cs %MA: cs = 176!!! and it works, how???
        OutputPort1.Sequence(m) = Seq(m);
    end

    % Allocate binary sequence from client payload (Host PC A)
    CPStart = cs;
    CPEnd = length(InputPort2.Sequence);

    for x = CPStart + 1 : CPEnd
        OutputPort1.Sequence(x) = InputPort2.Sequence(x);
    end
    
else
   
    % Allocate binary sequence to output port (empty)
    cs = length(Seq);
    for m = 1 : cs
        OutputPort1.Sequence(m) = 0; %MA: 
    end

    % Allocate binary sequence from client payload (empty)
    CPStart = cs;
    CPEnd = length(InputPort2.Sequence); %MA:

    for x = CPStart + 1 : CPEnd    %MA: 
        OutputPort1.Sequence(x) = 0; %MA: 
    end
%     
end





